Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.hibernate3.support
Class OpenSessionInViewInterceptor

    java.lang.Object
      org.springframework.orm.hibernate3.HibernateAccessor
          org.springframework.orm.hibernate3.support.OpenSessionInViewInterceptor

All Implemented Interfaces:
  BeanFactoryAware, InitializingBean, WebRequestInterceptor

    public class OpenSessionInViewInterceptor

extends HibernateAccessor
implements WebRequestInterceptor

Spring web request interceptor that binds a Hibernate `Session` to the thread for the entire processing of the request.

This class is a concrete expression of the "Open Session in View" pattern, which is a pattern that allows for the lazy loading of associations in web views despite the original transactions already being completed.

This interceptor makes Hibernate `Sessions` available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` or `JtaTransactionManager` as well as for non-transactional execution (if configured appropriately).

NOTE: This interceptor will by default not flush the Hibernate `Session`, with the flush mode being set to `FlushMode.NEVER`. It assumes that it will be used in combination with service layer transactions that handle the flushing: the active transaction manager will temporarily change the flush mode to `FlushMode.AUTO` during a read-write transaction, with the flush mode reset to `FlushMode.NEVER` at the end of each transaction. If you intend to use this interceptor without transactions, consider changing the default flush mode (through the `"flushMode"` property).

In contrast to `OpenSessionInViewFilter`, this interceptor is configured in a Spring application context and can thus take advantage of bean wiring. It inherits common Hibernate configuration properties from `HibernateAccessor`, to be configured in a bean definition.

WARNING: Applying this interceptor to existing logic can cause issues that have not appeared before, through the use of a single Hibernate `Session` for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate `Session` has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

Alternatively, turn this interceptor into deferred close mode, by specifying "singleSession"="false": It will not use a single session per request then, but rather let each data access operation or transaction use its own session (as would be the case without Open Session in View). Each of those sessions will be registered for deferred close though, which will actually be processed at request completion.

A single session per request allows for the most efficient first-level caching, but can cause side effects, for example on `saveOrUpdate` or when continuing after a rolled-back transaction. The deferred close strategy is as safe as no Open Session in View in that respect, while still allowing for lazy loading in views (but not providing a first-level cache for the entire request).

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `setSingleSession(boolean)`, `HibernateAccessor.setFlushMode(int)`, `OpenSessionInViewFilter`, `HibernateInterceptor`, `HibernateTransactionManager`, `SessionFactoryUtils.getSession(org.hibernate.SessionFactory, boolean)`, `TransactionSynchronizationManager`

Field Summary
`static String` | `PARTICIPATE_SUFFIX` Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

Fields inherited from class org.springframework.orm.hibernate3.HibernateAccessor
`FLUSH_ALWAYS, FLUSH_AUTO, FLUSH_COMMIT, FLUSH_EAGER, FLUSH_NEVER, logger`

Constructor Summary
`OpenSessionInViewInterceptor()` Create a new `OpenSessionInViewInterceptor`, turning the default flushMode to `FLUSH_NEVER`.

Method Summary
`void` | `afterCompletion(WebRequest request, Exception ex)` Unbind the Hibernate `Session` from the thread and close it (in single session mode), or process deferred close for all sessions that have been opened during the current request (in deferred close mode).
`protected String` | `getParticipateAttributeName()` Return the name of the request attribute that identifies that a request is already intercepted.
`protected boolean` | `isSingleSession()` Return whether to use a single session for each request.
`void` | `postHandle(WebRequest request, ModelMap model)` Flush the Hibernate `Session` before view rendering, if necessary.
`void` | `preHandle(WebRequest request)` Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.
`void` | `setSingleSession(boolean singleSession)` Set whether to use a single session for each request.

Methods inherited from class org.springframework.orm.hibernate3.HibernateAccessor
`afterPropertiesSet, applyFlushMode, convertHibernateAccessException, convertJdbcAccessException, convertJdbcAccessException, disableFilters, enableFilters, flushIfNecessary, getDefaultJdbcExceptionTranslator, getEntityInterceptor, getFilterNames, getFlushMode, getJdbcExceptionTranslator, getSessionFactory, setBeanFactory, setEntityInterceptor, setEntityInterceptorBeanName, setFilterName, setFilterNames, setFlushMode, setFlushModeName, setJdbcExceptionTranslator, setSessionFactory`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PARTICIPATE_SUFFIX

    public static final String PARTICIPATE_SUFFIX

  Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

  See Also:
    `getParticipateAttributeName()`, Constant Field Values

Constructor Detail

### OpenSessionInViewInterceptor

    public OpenSessionInViewInterceptor()

  Create a new `OpenSessionInViewInterceptor`, turning the default flushMode to `FLUSH_NEVER`.

  See Also:
    `HibernateAccessor.setFlushMode(int)`

Method Detail

### setSingleSession

    public void setSingleSession(boolean singleSession)

  Set whether to use a single session for each request. Default is "true".

  If set to false, each data access operation or transaction will use its own session (like without Open Session in View). Each of those sessions will be registered for deferred close, though, actually processed at request completion.

  See Also:
    `SessionFactoryUtils.initDeferredClose(org.hibernate.SessionFactory)`, `SessionFactoryUtils.processDeferredClose(org.hibernate.SessionFactory)`

### isSingleSession

    protected boolean isSingleSession()

  Return whether to use a single session for each request.

### preHandle

    public void preHandle(WebRequest request)
                   throws DataAccessException

  Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.

  Specified by:
    `preHandle` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
  Throws:
    `DataAccessException`
  See Also:
    `SessionFactoryUtils.getSession(org.hibernate.SessionFactory, boolean)`

### postHandle

    public void postHandle(WebRequest request,
                           ModelMap model)
                    throws DataAccessException

  Flush the Hibernate `Session` before view rendering, if necessary.

  Note that this just applies in `single session mode`!

  The default is `FLUSH_NEVER` to avoid this extra flushing, assuming that service layer transactions have flushed their changes on commit.

  Specified by:
    `postHandle` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
    `model` - the map of model objects that will be exposed to the view (may be `null`). Can be used to analyze the exposed model and/or to add further model attributes, if desired.
  Throws:
    `DataAccessException`
  See Also:
    `HibernateAccessor.setFlushMode(int)`

### afterCompletion

    public void afterCompletion(WebRequest request,
                                Exception ex)
                         throws DataAccessException

  Unbind the Hibernate `Session` from the thread and close it (in single session mode), or process deferred close for all sessions that have been opened during the current request (in deferred close mode).

  Specified by:
    `afterCompletion` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
    `ex` - exception thrown on handler execution, if any
  Throws:
    `DataAccessException`
  See Also:
    `TransactionSynchronizationManager`

### getParticipateAttributeName

    protected String getParticipateAttributeName()

  Return the name of the request attribute that identifies that a request is already intercepted.

  The default implementation takes the `toString()` representation of the `SessionFactory` instance and appends `PARTICIPATE_SUFFIX`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.